package com.thomaso.numeric;
/* Copyright (@)1999, Thomas Andrews */
/* Free for non-commercial use       */
import java.math.BigInteger;
import java.util.Vector;
import java.util.Enumeration;

public class BigCombo {

    static private Vector pascal=null;
    static BigInteger one=new BigInteger("1");
    static BigInteger zero=new BigInteger("0");

    static private synchronized void atDepth(int rowNum) {

	if (pascal==null) {
	    pascal=new Vector();
	    Vector row0=new Vector();
	    row0.addElement(one);
	    pascal.addElement(row0);
	}

	int rows;
	while ((rows=pascal.size())<=rowNum) {
	    Vector previousRow=(Vector)pascal.elementAt(rows-1);
	    Vector newRow=new Vector();

	    BigInteger prevValue=zero;

	    Enumeration values=previousRow.elements();
	    BigInteger value;

	    while (values.hasMoreElements()) {
	        value=(BigInteger)values.nextElement();
		newRow.addElement(value.add(prevValue));
		prevValue=value;
	    }
	    newRow.addElement(one);
	    pascal.addElement(newRow);
	}
    }

    static public BigInteger choose(int n,int k) {
	if (n<0 || k>n || k<0) { return zero; }

	atDepth(n);
	Vector row=(Vector)pascal.elementAt(n);
	return (BigInteger)row.elementAt(k);	
    }

    static public void main(String args[]) {
	int cardcount=36;
	BigInteger count=choose(26,13).multiply(choose(39,13))
		.multiply(choose(52,13));
        BigInteger index=new BigInteger("1");
        BigInteger increment=count.divide(new BigInteger("4"));
	for (int i=0; i<4; i++) {
		System.out.println(index);
		index=index.add(increment);
	}
    }
}
